#!/usr/bin/python
# coding=utf8

import cgi, shutil
from os import path, fstat, stat, listdir, readlink
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
from urllib import unquote_plus, unquote, quote
from ConfigParser import ConfigParser
from opendir import opendir
from xml.sax import saxutils

class MyHandler(BaseHTTPRequestHandler):
    def output_wiki_page(self, lang, article):
        try:
            file = open(path.join(config.get("main", "dump_folder"), lang, article), "r")
        except IOError:
            self.output_error_page(lang, article)
        else:
            self.write_header()
            #clever me uses copyfileobj to not fill memory on filehandle r/w
            shutil.copyfileobj(open(path.join(lang, "static/header")), self.wfile)
            self.wfile.write( file.readline() )
            shutil.copyfileobj(open(path.join(lang, "static/middle")), self.wfile)
            shutil.copyfileobj(file, self.wfile )
            shutil.copyfileobj(open(path.join(lang, "static/footer")), self.wfile)
        
    def output_category_page(self, lang, article, page):
        folder = path.join(config.get("main", "dump_folder"), lang, article)
        try:
            index = open(path.join(folder, "index"), "r")
        except IOError:
            self.output_error_page(lang, article)
        else:
            self.write_header()
            #clever me uses copyfileobj to not fill memory on filehandle r/w
            shutil.copyfileobj(open(path.join(lang, "static/header")), self.wfile)
            self.wfile.write( index.readline() )
            shutil.copyfileobj(open(path.join(lang, "static/middle")), self.wfile)
            shutil.copyfileobj(index, self.wfile )
            d = opendir(folder)
            
            #seek to page if necessary
            if page > 1:
                for i in xrange(100*(page-1)):
                    d.read()
            
            last_page = False
            
            for i in xrange(100):
                filename = d.read()
                if filename:
                    if filename not in [".","..","index"]:
                        link = '<a href="%s">%s</a><br />'%(quote(readlink(path.join(folder,filename))[3:]),saxutils.escape(filename))
                        self.wfile.write( link )
                else:
                    last_page = True
                    break
                
            
            if page > 1:
                self.wfile.write('<a href="/%s/%s?page=%i">« zurück</a>'%(lang, article, page-1))
            
            if not last_page:
                self.wfile.write(' <a href="/%s/%s?page=%i">vor »</a>'%(lang, article, page+1))
            
            shutil.copyfileobj(open(path.join(lang, "static/footer")), self.wfile)
    
    def output_error_page(self, lang, article):
        self.send_response(404)
        self.send_header('Content-type', 'application/xml')
        self.end_headers()
        shutil.copyfileobj(open(path.join(lang, "static/header")), self.wfile)
        self.wfile.write( "ERROR - %s not available in language '%s'"%(article, lang) )
        shutil.copyfileobj(open(path.join(lang, "static/middle")), self.wfile)
        shutil.copyfileobj(open(path.join(lang, "static/error")), self.wfile )
        shutil.copyfileobj(open(path.join(lang, "static/footer")), self.wfile)
        
    def output_language_chooser(self):
        self.write_header()
        self.wfile.write('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"> <head> <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /></head> <body>')
        for i in iw_enabled:
            self.wfile.write('<a href="/%s">%s</a><br />'%(i,i))
        self.wfile.write('</body></html>')
        
    def output_language_index(self, lang):
        self.write_header()
        shutil.copyfileobj(open(path.join(lang, "static/header")), self.wfile)
        self.wfile.write( "Welcome to mokopedia %s"%lang )
        shutil.copyfileobj(open(path.join(lang, "static/middle")), self.wfile)
        shutil.copyfileobj(open(path.join(lang, "static/index")), self.wfile )
        shutil.copyfileobj(open(path.join(lang, "static/footer")), self.wfile)
        
    def output_image_redirect(self, lang, article):
        redirect = open(path.join(lang, "static/image_redirect")).read()
        self.write_header()
        self.wfile.write(redirect%{"lang":lang, "article":article})
    
    def write_header(self):
        #wstat = fstat(file.fileno())
        self.send_response(200)
        self.send_header('Content-type', 'application/xml')
        #self.send_header("Content-Length", str(wstat.st_size + stat("de/static/header").st_size + stat("de/static/middle").st_size + stat("de/static/footer").st_size))
        #self.send_header("Last-Modified", self.date_time_string(wstat.st_mtime))
        self.end_headers()
    
    def do_GET(self):
        global config
        
        i = self.path.rfind('?')
        if i >= 0:
            self.path, query = self.path[:i], self.path[i+1:]
            if query:
                dict = cgi.parse_qs(query)
                page = int(dict["page"][0])
            else:
                page = 1
        else:
            page = 1
            
        #EXPERTENPROGRAMMIERER
        addr = [ unquote(i) for i in self.path.split('/') if i ]
        
        if self.path.endswith("static/main.css"):
            shutil.copyfileobj(open(path.join(addr[0], "static/main.css")), self.wfile)
        elif self.path == "/poweredby_mediawiki_88x31.png":
            shutil.copyfileobj(open("poweredby_mediawiki_88x31.png"), self.wfile)
        elif self.path == "/wikimedia-button.png":
            shutil.copyfileobj(open("wikimedia-button.png"), self.wfile)
        elif self.path == "/headbg.jpg":
            shutil.copyfileobj(open("headbg.jpg"), self.wfile)
        elif self.path == "/bullet.jpg":
            shutil.copyfileobj(open("bullet.jpg"), self.wfile)
        elif len(addr) > 0 and addr[0] in iw_enabled:
            if len(addr) == 2:
                if addr[1].startswith(config.get(addr[0], "image")+":"):
                    self.output_image_redirect(lang=addr[0], article=addr[1])
                elif addr[1].startswith(config.get(addr[0], "category")+":"):
                    self.output_category_page(lang=addr[0], article=addr[1], page=page)
                else:
                    self.output_wiki_page(lang=addr[0], article=addr[1])
            else:
                self.output_language_index(lang=addr[0])
        else:
            self.output_language_chooser()
        
        def do_POST(self):
            global rootnode
            try:
                ctype, pdict = cgi.parse_header(self.headers.getheader('content-type'))
                if ctype == 'multipart/form-data':
                    query=cgi.parse_multipart(self.rfile, pdict)
                self.send_response(301)
                
                self.end_headers()
                upfilecontent = query.get('upfile')
                print "filecontent", upfilecontent[0]
                self.wfile.write("<HTML>POST OK.<BR><BR>");
                self.wfile.write(upfilecontent[0]);
                
            except :
                pass

def main():
    global config, iw_enabled
    
    config = ConfigParser()
    config.read("mokopedia.cfg")
    
    iw_enabled = []
    for section in config.sections():
        if "main" not in section and config.getint(section, "enabled"):
            iw_enabled.append(section)
    
    try:
        server = HTTPServer(('', config.getint("main", "port")), MyHandler)
        print 'httpserver started'
        server.serve_forever()
    except KeyboardInterrupt:
        print '^C received, shutting down server'
        server.socket.close()

if __name__ == '__main__':
    main()
